import time

def get_tick():
	return int(time.time()*1000)

class Pattern:

	def __init__(self):
		self.point = []
		self.pos = 0
		self.sx = 0
		self.sy = 0
		self.ptick = 500
		self.stick = get_tick()
		self.pos_len = 0
	
	def set_tick(self,stick,ptick = -1):
		self.stick = stick
		if( ptick > 0 ):
			self.ptick = ptick
	
	def set_start(self,sx,sy):
		self.sx = sx
		self.sy = sy
	
	def add_point(self,x,y):
		self.point.append( (x,y) )
		self.pos_len = self.pos_len + 1

	def update(self,tick):
		if self.pos_len == 0 :
			return
		self.pos = (int( (tick-self.stick)/self.ptick ))%self.pos_len
	
	def get_pos(self):
		(x,y) = self.point[ self.pos ]
		return ( self.sx + x , self.sy + y )

		
def LinePattern( size , ix , iy , x , y ):
	res = Pattern()
	print (x,y)
	res.set_start( x , y )
	tx = 0
	ty = 0
	for i in range(size):
		res.add_point( tx , ty )
		tx = tx + ix
		ty = ty + iy
	tx = tx - ix
	ty = ty - iy
	for i in range(size):
		res.add_point( tx , ty )
		tx = tx - ix
		ty = ty - iy
	return res

def LoadPatterns( file ):
	res = []
	f = open( file , 'r' )
	lines = f.readlines()
	tmp = 0
	for line in lines :
		items = line.strip().split(' ')
		if items[0] == 'line' :
			tmp = LinePattern( int(items[1]) , int( items[2]) , int( items[3] ) , int( items[4]  ) , int( items[5] ) )
		if( tmp != 0 ) :
			res.append( tmp )
			tmp = 0
		print items
	return res
	
class Map:

	def __init__(self,file,pfile):
		self.rendered = 0
		self.px = 1
		self.py = 1
		self.can_move = 1
		f = open(file,'r')
		self.patterns = LoadPatterns( pfile )
		self.data = []
		self.dataTmp = []
		lines = f.readlines()
		c = 0
		for line in lines :
			tmpa = []
			self.data.append( line.strip() )
			for cin in self.data[c] :
				tmpa.append( cin )
			self.dataTmp.append( tmpa )
			c = c + 1
		
		self.lx = len( self.dataTmp )
		self.ly = len( self.dataTmp[0] )
	
	def update(self,tick):
		for pat in self.patterns:
			pat.update( tick )
	
	def start(self):
		self.px = 1
		self.py = 1
		tick = get_tick()
		for pat in self.patterns:
			pat.set_tick( tick )
		self.update( tick )
	
	def startRender(self):
		self.can_move = 0
		if( self.rendered == 1 ):
			print "ERROR: startRender not working"
			return
		for pat in self.patterns:
			(x ,y) = pat.get_pos()
			u = 'O'
			if self.data[x][y] == 'x' :
				u = 'x'
			self.dataTmp[ x ][ y ] = u
		if self.dataTmp[ self.px ][ self.py ] == '.' :
			self.dataTmp[ self.px ][ self.py ] = 'B'
		self.rendered = 1
			
	def endRender(self):
		self.can_move = 1
		if( self.rendered == 0 ):
			print "ERROR: endRender not working"
			return
		for pat in self.patterns:
			(x ,y) = pat.get_pos()
			self.dataTmp[ x ][ y ] = self.data[x][y]
		self.dataTmp[ self.px ][self.py ] = self.data[self.px][self.py]
		self.rendered = 0
	
	def PlayerState(self):
		self.startRender()
		tmp = self.dataTmp[ self.px ][ self.py ]
		self.endRender()
		if tmp != 'B':
			return 1
		return 0;
	
	def PlayerPlusXY( self , ppx , ppy ):
		if self.can_move != 1 :
			return
		px = self.px + ppx
		py = self.py + ppy
		if px < 0 :
			px = 0
		if py < 0 :
			py = 0
		if py >= self.ly :
			py = self.ly-1
		if px >= self.lx :
			px = self.lx-1
		self.px = px
		self.py = py
	
	def console(self):
		self.can_move = 0
		self.startRender()
		for line in self.dataTmp :
			tmp = ''
			for ch in line :
				tmp = tmp + ch
			print tmp
		self.endRender()
		self.can_move = 1

#m = Map( 'map1.txt' , 'pat1.txt' )
#m.start()
#while( 1 == 1 ):
#	tick = get_tick()
#	m.update( tick )
#	if tick%500 == 0 :
#		m.console()
#		print '------------------------'
#		time.sleep( 0.2 )
	#raw_input()
